unit Ratespiel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, jpeg;

type
  THangman2000 = class(TForm)
    Galgenbilder: TImage;
    DateiLesen: TOpenDialog;
    LabelD: TLabel;
    PanelWort: TPanel;
    LabelWort: TLabel;
    LabelV: TLabel;
    LabelLoesung: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button7: TButton;
    Button6: TButton;
    Button8: TButton;
    Button10: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button9: TButton;
    Button11: TButton;
    Button12: TButton;
    Button17: TButton;
    Button16: TButton;
    Button18: TButton;
    Button20: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Button19: TButton;
    Button21: TButton;
    Button22: TButton;
    Button27: TButton;
    Button26: TButton;
    Button28: TButton;
    Button30: TButton;
    Button23: TButton;
    Button24: TButton;
    Button25: TButton;
    Button29: TButton;
    MainMenu: TMainMenu;
    Datei: TMenuItem;
    N1: TMenuItem;
    Beenden: TMenuItem;
    Oeffnen: TMenuItem;
    Spielen: TMenuItem;
    Level: TMenuItem;
    Leicht: TMenuItem;
    Normal: TMenuItem;
    Schwierig: TMenuItem;
    LAnzeige: TMenuItem;
    aktivieren: TMenuItem;
    deaktivieren: TMenuItem;
    LabelBegriffe: TLabel;
    Hiscore: TMenuItem;
    LabelSN: TLabel;
    EditSN: TEdit;
    LabelK: TLabel;
    Hilfe1: TMenuItem;
    Tips: TMenuItem;
    N2: TMenuItem;
    Info: TMenuItem;
    procedure ButtonEinAus(Zustand:Boolean);
    procedure SpielenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonClick(Sender: TObject);
    procedure OeffnenClick(Sender: TObject);
    procedure BeendenClick(Sender: TObject);
    procedure LeichtClick(Sender: TObject);
    procedure NormalClick(Sender: TObject);
    procedure SchwierigClick(Sender: TObject);
    procedure aktivierenClick(Sender: TObject);
    procedure deaktivierenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure HiscoreClick(Sender: TObject);
    procedure Codieren(var Zeile:String;Wie:Integer);
    procedure Sortieren;
    procedure InfoClick(Sender: TObject);
    procedure TipsClick(Sender: TObject);
  private { Private-Deklarationen }  // globale Variablen
   BildDatei,Wort,Anzeige,Alfa,Loesung:String;
   LW,Treffer,Versuche,Grad,Position:Integer;
   Liste:TStrings;
  public
    { Public-Deklarationen }
   HListe:TStrings;
   Konto:Integer;
  end;

var
  Hangman2000: THangman2000;

implementation
uses Hiscore, Einsatz, Info, Regeln;

{$R *.DFM}
{$R+,Q+}
 const Kino=3;HiscoreName='Galgen.hsc';NamenZahl=10;
       Namen:Array[1..NamenZahl]of String=('Gandalf','Frodo','Sam','Aragorn',
                                           'Legolas','Gimli','Pippin','Merry',
                                           'Boromir','Gollum');

 procedure THangman2000.OeffnenClick(Sender: TObject);
  var DatName:String;
  begin
   with DateiLesen do
    begin
     Filter:='Wortdateien (*.hgm) |*.hgm';
     DefaultExt:='hgm';
     if Execute then
      begin
       Liste.LoadFromFile(Filename);
       DatName:=ExtractFilename(FileName);
       LabelD.Caption:=Copy(DatName,1,Pos('.',DatName)-1);
       LabelBegriffe.Caption:=IntToStr(Liste.Count)+' Begriff';
       if Liste.Count<>1 then LabelBegriffe.Caption:=LabelBegriffe.Caption+'e';
       if Liste.Count>0 then
        begin
         Spielen.Enabled:=True;
         Konto:=1000;
         LabelK.Caption:='Dein Kontostand: '+IntToStr(Konto);
        end
      end
    end
  end;

 procedure THangman2000.ButtonEinAus(Zustand:Boolean);
  var K:Integer;
      Button:TButton;
  begin
   for K:=1 to Length(Alfa) do
    begin
     Button:=TButton(FindComponent('Button'+IntToStr(K)));
     Button.Enabled:=Zustand;
    end;
  end;

 procedure THangman2000.SpielenClick(Sender: TObject);
  var K,DatNr:Integer;
      DateiName:String;
  begin
   if Liste.Count=0 then
    begin
     MessageDlg('Es gibt NICHTS zu spielen! Lade eine Wortdatei!',mtError,[mbOk],0);
     exit;
    end;
   if Konto<=0 then
    begin
     MessageDlg('Du hast kein Geld mehr! Lade eine Wortdatei!',mtError,[mbOk],0);
     exit;
    end;
   Oeffnen.Enabled:=False;Level.Enabled:=False;
   DatNr:=random(Kino);
   case DatNr of
    0: begin BildDatei:='Auto';Versuche:=9 end;
    1: begin BildDatei:='Galgen';Versuche:=6 end;
    2: begin BildDatei:='USA';Versuche:=9 end;
   end;
   LabelV.Caption:='Du hast noch '+IntToStr(Versuche div Grad)+' Versuche!';
   Geld.ShowModal;
   dec(Konto,Geld.Betrag);
   LabelK.Caption:='Dein Kontostand: '+IntToStr(Konto);
   Position:=Random(Liste.Count);
   Wort:=Liste[Position];
   Loesung:=Wort;
   Treffer:=0;LW:=Length(Wort);Anzeige:='';
   DateiName:=BildDatei+IntToStr(Versuche)+'.bmp';
   if FileExists(DateiName) then GalgenBilder.Picture.LoadFromFile(DateiName);
   for K:=1 to LW do Anzeige:=Anzeige+'?';
   LabelWort.Caption:=Anzeige;LabelLoesung.Visible:=False;
   ButtonEinAus(True);
  end;

 procedure THangman2000.Codieren(var Zeile:String;Wie:Integer);
  var Geheim:String;
      K,LA:Integer;
  Begin
   Geheim:='';LA:=223;
   for K:=1 to Length(Zeile) do
    Geheim:=Geheim+char(32+(ord(Zeile[K])+Wie*Random(LA)+LA-32) mod LA);
   Zeile:=Geheim;
  End;

 procedure THangman2000.FormCreate(Sender: TObject);
  var DateiName,Zeile:String;
      DatNr,K:Integer;
  begin
   Liste:=TStringList.Create; // Liste erschaffen
   HListe:=TStringList.Create;
   try
    HListe.LoadFromFile(HiscoreName);
    RandSeed:=6230;
    for K:=0 to HListe.Count-1 do
     begin
      Zeile:=HListe[K];
      Codieren(Zeile,-1); // entschlsseln
      HListe[K]:=Zeile;
     end;
   except
    MessageDlg('Datei '+HiscoreName+' nicht gefunden!',mtError,[mbOk],0);
    for K:=1 to 10 do
     HListe.Add(Format('%10d',[(11-K)*10000])+' - '+Format('%20s',[Namen[K]]));
   end;
   Alfa:='ABCDEFGHIJKLMNOPQRSTUVWXYZ ';Grad:=1;
   ButtonEinAus(False);
   DatNr:=random(Kino);
    case DatNr of
     0: BildDatei:='Auto';
     1: BildDatei:='Galgen';
     2: BildDatei:='USA';
    end;
   DateiName:=BildDatei+'Start.bmp';
   if FileExists(DateiName) then GalgenBilder.Picture.LoadFromFile(DateiName);
   randomize;
  end;

 procedure THangman2000.FormDestroy(Sender: TObject);
  begin Liste.Free end; // Liste lschen

 procedure THangman2000.Sortieren;
  var sortiert:Boolean;
      K,Zahl1,Zahl2:Integer;
      Tausch:String;
  begin
   repeat
    sortiert:=True;
    for K:=0 to HListe.Count-2 do
     begin
      Zahl1:=StrToInt(copy(HListe[K],1,Pos(' -',HListe[K])-1));
      Zahl2:=StrToInt(copy(HListe[K+1],1,Pos(' -',HListe[K+1])-1));
      if Zahl1<Zahl2 then
       begin
        Tausch:=HListe[K];
        HListe[K]:=HListe[K+1];
        HListe[K+1]:=Tausch;
        sortiert:=False;
       end
     end
   until sortiert
  end;

 procedure THangman2000.ButtonClick(Sender: TObject);
  var Zeichen:Char;
      wo,K,Minimum:Integer;
      Button:TButton;
      DateiName,Zeile:String;
  begin
   for K:=1 to Length(Alfa) do
    begin
     Button:=TButton(FindComponent('Button'+IntToStr(K)));
     if Button=Sender then
      begin Zeichen:=Alfa[K];Button.Enabled:=False;Break end
    end;
   if Pos(Zeichen,Wort)=0 then
    begin
     dec(Versuche,Grad);
     DateiName:=BildDatei+IntToStr(Versuche)+'.bmp';
     if FileExists(DateiName) then GalgenBilder.Picture.LoadFromFile(DateiName);
     if Versuche=0 then
      begin
       LabelV.Caption:='Du bist ein Looser!!';
       Oeffnen.Enabled:=True;Level.Enabled:=True;
       LabelLoesung.Caption:='die Lsung : '+Loesung;
       if Aktivieren.Checked then
        begin
         LabelLoesung.Visible:=True;
         Liste.Delete(Position);
         LabelBegriffe.Caption:=IntToStr(Liste.Count)+' Begriff';
         if Liste.Count<>1 then LabelBegriffe.Caption:=LabelBegriffe.Caption+'e';
         if Liste.Count=0 then Spielen.Enabled:=False;
        end;
       ButtonEinAus(False);exit
      end;
     LabelV.Caption:='Du hast noch '+IntToStr(Versuche div Grad)+' Versuch';
     if Versuche div Grad>1 then LabelV.Caption:=LabelV.Caption+'e'
    end
   else
    begin
     repeat
      wo:=Pos(Zeichen,Wort);
      if wo>0 then
       begin
        inc(Treffer);Wort[wo]:='*';
        Anzeige[wo]:=Zeichen;
       end
     until wo=0;
     LabelWort.Caption:=Anzeige;
     if Treffer=LW then
      begin
       LabelV.Caption:='Bravo, du hast das Wort ermittelt!';
       inc(Konto,(Grad+1)*Geld.Betrag);
       LabelK.Caption:='Dein Kontostand: '+IntToStr(Konto);
       Zeile:=HListe[HListe.Count-1];
       Minimum:=StrToInt(copy(Zeile,1,Pos(' -',Zeile)-1));
       if Minimum<Konto then
        begin
         HListe.Add(Format('%10d',[Konto])+' - '+Format('%20s',[EditSN.Text]));
         Sortieren;
         HListe.Delete(HListe.Count-1);
         HSL.ScoreListe.Clear;
         HSL.ScoreListe.Items:=HListe;
         HSL.ScoreListe.Items.Insert(0,Format('%8s',['Gewinn in '])+Format('%18s',['Name']));
         HSL.ShowModal;
        end;
       Oeffnen.Enabled:=True;Level.Enabled:=True;
       ButtonEinAus(False);
       Liste.Delete(Position);
       LabelBegriffe.Caption:=IntToStr(Liste.Count)+' Begriff';
       if Liste.Count<>1 then LabelBegriffe.Caption:=LabelBegriffe.Caption+'e';
       if Liste.Count=0 then Spielen.Enabled:=False;
      end
    end;
  end;

 procedure THangman2000.BeendenClick(Sender: TObject);
  begin close end;

 procedure THangman2000.LeichtClick(Sender: TObject);
  begin
   Grad:=1;
   Leicht.Checked:=True;
  end;

 procedure THangman2000.NormalClick(Sender: TObject);
  begin
   Grad:=2;
   Normal.Checked:=True;
  end;

 procedure THangman2000.SchwierigClick(Sender: TObject);
  begin
   Grad:=3;
   Schwierig.Checked:=True;
  end;

 procedure THangman2000.aktivierenClick(Sender: TObject);
  begin Aktivieren.Checked:=True end;

 procedure THangman2000.deaktivierenClick(Sender: TObject);
  begin DeAktivieren.Checked:=True end;

 procedure THangman2000.FormCloseQuery(Sender: TObject;var CanClose: Boolean);
  var K:Integer;
      Zeile:String;
  begin
   if MessageDlg('Beenden?',mtConfirmation,[mbYes,mbNo],0)=mrYes then
    begin
     try
      RandSeed:=6230;
      for K:=0 to HListe.Count-1 do
       begin
        Zeile:=HListe[K];
        Codieren(Zeile,1); // verschlsseln
        HListe[K]:=Zeile;
       end;
      HListe.SaveToFile(HiscoreName);
     except
       MessageDlg('Datei '+HiscoreName+' kann nicht gespeichert werden!',mtError,[mbOk],0);
      end;
     CanClose:=True
    end
   else CanClose:=False
  end;

 procedure THangman2000.HiscoreClick(Sender: TObject);
  begin HSL.ShowModal end;

 procedure THangman2000.InfoClick(Sender: TObject);
  begin InfoBox.ShowModal end;

 procedure THangman2000.TipsClick(Sender: TObject);
  begin RegelnBox.ShowModal end;

end.

